<?php

// checkCCapikey handler function...
add_action('wp_ajax_cUs_CtCt_checkMCapikey', 'cUs_CtCt_checkMCapikey_callback');
function cUs_CtCt_checkMCapikey_callback() {
    
    $api_key    =   trim($_REQUEST[apikey]);
    $username   =   trim($_REQUEST[UserName]);
    $password   =   trim($_REQUEST[Pass]);
    
    //apis instances
    $cUs_CtCt_API = new cUs_CtCt_List($username,$password,$api_key); 
    $userData = $cUs_CtCt_API->testCredentials();
    
    if(empty($userData)):
        
            echo 2; //INVALID APIKEY
        
    else:
        echo 1; //VALID APIKEY
    
        $cUs_CtCt_userData = array(
            'fname' => trim($_REQUEST[Fname]),
            'lname' => trim($_REQUEST[LName]),
            'username' => trim($username),
            'password' => trim($password),
            'CtCt_apikey' => $api_key
        );
        
        $cUs_CtCt_lists = $cUs_CtCt_API->getLists();
        
        update_option('cUs_CtCt_settings_CC_lists', $cUs_CtCt_lists);
        update_option('cUs_CtCt_settings_userData', $cUs_CtCt_userData);
    endif;
    
    die();
}

// getMCList handler function...
add_action('wp_ajax_cUs_CtCt_getLists', 'cUs_CtCt_getLists_callback');
function cUs_CtCt_getLists_callback() {
    
    $cUs_CtCt_lists = get_option('cUs_CtCt_settings_CC_lists'); //get the saved  user LIST MATRIX
    $userData = get_option('cUs_CtCt_settings_userData'); //get the saved user data
    $xHTML = '';
    global $current_user;
    get_currentuserinfo();

    if($userData):

        if ( is_array($cUs_CtCt_lists) && !empty($cUs_CtCt_lists) ) : $i=1;
            foreach($cUs_CtCt_lists as $key => $list){
                
                $xHTML .= '<input value="'.getListIdByURL($list["id"]).'" type="checkbox" name="ctct_lists" id="ctct_list_'. $i .'" ';
                    ($i==1)? $xHTML .= 'checked="checked"' : $xHTML .= "";
                $xHTML .= ' /> <label for="ctct_list_'. $i.'">[ '.getListIdByURL($list["id"]).' ] - '.$list['title'].'</label><br/>'; 
                
                $i++;
                
            }
            
            $aryResponse = array(
                'options'   => $xHTML,
                'fname'     => ( strlen($userData[fname]) ) ? $userData[fname] : $current_user->user_firstname,
                'lname'     => ( strlen($userData[lname]) ) ? $userData[lname] : $current_user->user_lastname,
                'email'     => $current_user->user_email,
                'status'    => 0//NO EERORS
            );
            
            
        else:
            $aryResponse = array('status' => 1); //empty matrix list
        endif;

    else:    
        $aryResponse = array('status' => 2); //empty matrix listecho 2; // no user data
    endif;
    
    echo json_encode($aryResponse);
    
    die();
}
function getListIdByURL($URL){
    if(strlen($URL)):
        $aryListID = explode('/', $URL);
        return $aryListID[7];
    else:
        return FALSE;
    endif;
}

// sendClientList handler function...
add_action('wp_ajax_cUs_CtCt_sendClientList', 'cUs_CtCt_sendClientList_callback');
function cUs_CtCt_sendClientList_callback() {
    
    if      ( !strlen($_REQUEST[Fname]) ):      echo 'Missing First Name, is a required fieldsss!';      die();
    elseif  ( !strlen($_REQUEST[LName]) ):      echo 'Missing Last Name, is a required field!';       die();
    elseif  ( !strlen($_REQUEST[uEmail]) ):     echo 'Missing/Invalid Email, is a required field!';   die();
    elseif  ( !strlen($_REQUEST[website]) ):    echo 'Missing Website, is a required field!';         die();
    else:
    
        $cUs_CtCt_userData = get_option('cUs_CtCt_settings_userData'); //get the saved user data

        $aryListsID = $_REQUEST[listID];
        $aryListID = array();
        foreach ($aryListsID as $listID){ $aryListID[] = $listID[value]; }
        $listids = implode(',', $aryListID);

        $postData = array(
            'fname' => (strlen($cUs_CtCt_userData[fname]))? $cUs_CtCt_userData[fname] : $_REQUEST[Fname],
            'lname' => (strlen($cUs_CtCt_userData[lname]))? $cUs_CtCt_userData[lname] : $_REQUEST[LName],
            'email' => $_REQUEST[uEmail],
            'username' => $cUs_CtCt_userData[username],
            'password' => $cUs_CtCt_userData[password],
            'CtCt_apikey' => $cUs_CtCt_userData[CtCt_apikey],
            'website' => $_REQUEST[website],
            'listID' => $listids
        );

        update_option('cUs_CtCt_settings_userData', $postData);
        update_option('cUs_CtCt_settings_list_ID', $listids);

        $cUs_CtCt_API = new cUsComAPI_CtCt();
        $cUs_CtCt_API_result = $cUs_CtCt_API->createCustomer($postData);


        if($cUs_CtCt_API_result) :

            $cUs_json = json_decode($cUs_CtCt_API_result);

            switch ( $cUs_json->status  ) :

                case 'success':
                    echo 1;//GREAT
                    update_option('cUs_CtCt_settings_form_key', $cUs_json->form_key ); //finally get form key form contactus.com // SESSION IN

                    //DELETE USER DATA
                    unset( $postData[ username ] );
                    unset( $postData[ password ] );
                    update_option( 'cUs_CtCt_settings_userData',$postData );
                    
                    $aryFormOptions = array( //DEFAULT SETTINGS / FIRST TIME
                        'tab_user'          => 1,
                        'cus_version'       => 'tab'
                    ); 
                    update_option('cUs_CtCt_FORM_settings', $aryFormOptions );//UPDATE FORM SETTINGS
                    
                    break;

                case 'error':

                    if($cUs_json->error[0] == 'Email exists'):
                        echo 2;//ALREDY CUS USER
                    else:
                        //ANY ERROR
                        echo $cUs_json->error;
                    endif;
                break;

            endswitch;
         else:
             //echo 3;//API ERROR
             echo $cUs_json->error;
             //$cUs_CtCt_API->resetData(); //RESET DATA
         endif;
         
     endif;//VALIDATION
    
    die();
}

// loginAlreadyUser handler function...
add_action('wp_ajax_cUs_CtCt_loginAlreadyUser', 'cUs_CtCt_loginAlreadyUser_callback');
function cUs_CtCt_loginAlreadyUser_callback() {
    $cUs_CtCt_API = new cUsComAPI_CtCt();
    $cUs_email = $_REQUEST['email'];
    $cUs_pass = $_REQUEST['pass'];
    
    $cUs_CtCt_API_result = $cUs_CtCt_API->getFormKeyAPI($cUs_email, $cUs_pass); //api hook;
    
    $postData = get_option('cUs_CtCt_settings_userData'); //get the saved user data
    
    if($cUs_CtCt_API_result){
        $cUs_json = json_decode($cUs_CtCt_API_result);

        switch ( $cUs_json->status  ) :
            case 'success':
                
                $cUsMC_API_UPDATE = $cUs_CtCt_API->updateDeliveryOptions($postData,$cUs_pass, $cUs_json->form_key); //UPDATE DELIVERY OPTIONS;
                
                update_option('cUs_CtCt_settings_form_key', $cUs_json->form_key);
                
                $aryFormOptions = array( //DEFAULT SETTINGS / FIRST TIME
                    'tab_user'          => 1,
                    'cus_version'       => 'tab'
                ); 
                update_option('cUs_CtCt_FORM_settings', $aryFormOptions );//UPDATE FORM SETTINGS
                
                //update_option('cUs_CtCt_settings_userData', $postData);
                echo 1;
                break;

            case 'error':
                echo $cUs_json->error;
                //$cUs_CtCt_API->resetData(false); //RESET DATA
                break;
        endswitch;
    }
    
    die();
}

// logoutUser handler function...
add_action('wp_ajax_cUs_CtCt_logoutUser', 'cUs_CtCt_logoutUser_callback');
function cUs_CtCt_logoutUser_callback() {
    
    $cUs_CtCt_API = new cUsComAPI_CtCt();
    $cUs_CtCt_API->resetData(true); //RESET DATA
    
    echo 'Deleted.... User data'; //none list
    
    die();
}

// sendTemplateID handler function...
add_action('wp_ajax_cUs_CtCt_sendTemplateID', 'cUs_CtCt_sendTemplateID_callback');
function cUs_CtCt_sendTemplateID_callback() {
    echo 1; //none list
    
    die();
}

?>
