
var cUsCtCt_myjq = jQuery.noConflict();

cUsCtCt_myjq(window).error(function(e){
    e.preventDefault();
});

cUsCtCt_myjq(document).ready(function($) {
    
    
    try{
        cUsCtCt_myjq( "#cUs_tabs" ).tabs({active: false});
        cUsCtCt_myjq( "#cUs_exampletabs" ).tabs({active: false});

        cUsCtCt_myjq( '.options' ).buttonset();
        cUsCtCt_myjq( '#inlineradio' ).buttonset();

        cUsCtCt_myjq( "#terminology" ).accordion({
            collapsible: true,
            heightStyle: "content",
            active: false,
            icons: { "header": "ui-icon-info", "activeHeader": "ui-icon-arrowreturnthick-1-n" }
        });
        cUsCtCt_myjq( "#form_examples, #tab_examples" ).accordion({
            collapsible: true,
            heightStyle: "content",
            icons: { "header": "ui-icon-info", "activeHeader": "ui-icon-arrowreturnthick-1-n" }
        });
       
    }catch(err){
        cUsCtCt_myjq('.advice_notice').html('Oops, something wrong happened, please try again later!').slideToggle().delay(1200).fadeOut(1200);
    }
    
    
    try{
        
        cUsCtCt_myjq("#selectable").selectable({
            selected: function(event, ui) { 
                cUsCtCt_myjq(ui.selected).addClass("ui-selected").siblings().removeClass("ui-selected");           
            }                   
        });
        
    }catch(err){
        console.log('Please upadate you WP version. ['+ err +']');
    }
    
    
    //SEND API KEY AJAX CALL /////// STEP 1
    try{ 
       cUsCtCt_myjq('.cUs_CtCt_sendapikey').click(function() {
           
           var CtCt_ApiKey = cUsCtCt_myjq('#ctct_apikey').val();
           var CtCt_UserName = cUsCtCt_myjq('#ctct_username').val();
           var CtCt_Pass = cUsCtCt_myjq('#ctct_password').val();
           var postData = {};
           
           cUsCtCt_myjq('.advice_notice').hide();
           
           if(!CtCt_ApiKey.length){
               cUsCtCt_myjq('.advice_notice').html('Constant Contact API Key is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#ctct_apikey').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if(!CtCt_UserName.length){
               cUsCtCt_myjq('.advice_notice').html('Constant Contact User Name is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#ctct_username').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if(!CtCt_Pass.length){
               cUsCtCt_myjq('.advice_notice').html('Constant Contact User Password is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#ctct_password').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else{
               
                cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Loading . . .').attr({disabled:'disabled'});
                cUsCtCt_myjq('.loadingMessage').show();
                
                postData = {action: 'cUs_CtCt_checkMCapikey', apikey:CtCt_ApiKey,UserName:CtCt_UserName, Pass:CtCt_Pass};
                
                cUsCtCt_myjq.ajax({ type: "POST", url: ajax_object.ajax_url, data: postData,
                    success: function(data) {

                        switch(data){
                            case '1':
                                
                                message = 'You are already logged into you Constant Contact account, please continue with next steps.';
                                cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Connected . . .');
                                setTimeout(function(){
                                    cUsCtCt_getMClist();
                                },2000)
                                
                            break;
                            case '2':
                                message = 'There something wrong with your Constant Contact API Key, please try again!';
                                cUsCtCt_myjq('.advice_notice').html(message).show().delay(2900).fadeOut(1500);
                                cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Continue to Step 2').removeAttr('disabled');
                            break;
                        }
                        
                        cUsCtCt_myjq('.loadingMessage').fadeOut();

                    },
                    async: false
                });
           }
           
            
       });
       
       function cUsCtCt_getMClist(){
           cUsCtCt_myjq('.loadingMessage').show();
           cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Loading Lists. . .')
           cUsCtCt_myjq.ajax({ type: "POST", url: ajax_object.ajax_url, dataType: 'json', data: {action:'cUs_CtCt_getLists'},
                success: function(data) {
                    switch(data.status){
                        case 1:
                            message = "Seems like you don't have Contact List in you Constant Contact Account, please add at least one <a href='http://tinyurl.com/p7m2yz5' target='_blank'>here</a> to continue.";
                            cUsCtCt_myjq('.advice_notice').html(message).slideToggle();
                            
                            cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Reloading . . .');
                            
                            setTimeout(function(){
                                cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Continue to Step 2').removeAttr('disabled');
                            },3000)
                            
                        break;
                        case 2:
                            message = 'There something wrong with your Constant Contact API Key, please try again!';
                            cUsCtCt_myjq('.advice_notice').html(message).slideToggle().delay(1800).fadeOut(600);
                        break;
                        default:
                            cUsCtCt_myjq('#listid').html(data.options);
                            
                            cUsCtCt_myjq('#ctct_first_name').val(data.fname);
                            cUsCtCt_myjq('#ctct_last_name').val(data.lname);
                            cUsCtCt_myjq('#ctct_email').val(data.email);
                            
                            cUsCtCt_myjq('.step1').slideUp().fadeOut();
                            cUsCtCt_myjq('.step2').slideDown().delay(800);
                        break;
                    }
                    cUsCtCt_myjq('.loadingMessage').fadeOut();

                },
                async: false
            });
       }
       
    }catch(err){
        cUsCtCt_myjq('.advice_notice').html('Oops, something wrong happened, please try again later!').slideToggle().delay(1200).fadeOut(1200);
    }
    
    
    //SENT LIST ID AJAX CALL /// STEP 2
    try{
        cUsCtCt_myjq('.cUs_CtCt_Sendlistid').click(function() {
           
           var CtCt_ApiKey = cUsCtCt_myjq('#apikey').val();
           var CtCt_Pass = cUsCtCt_myjq('#ctct_password').val();
           var CtCt_Fname = cUsCtCt_myjq('#ctct_first_name').val();
           var CtCt_LName = cUsCtCt_myjq('#ctct_last_name').val();
           var CtCt_email = cUsCtCt_myjq('#ctct_email').val();
           var CtCt_Website = cUsCtCt_myjq('#ctct_web').val();
           var bValid = checkRegexp( CtCt_email, /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i, "eg. sergio@jquery.com" );  
           var postData = {};
           
           var mcListID = cUsCtCt_myjq("input[name='ctct_lists']").serializeArray();
           cUsCtCt_myjq('.loadingMessage').show();
           
           if(!mcListID.length){
               cUsCtCt_myjq('.advice_notice').html('You must choose a Constant Contact List at least!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#apikey').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if(!CtCt_Fname.length){
               cUsCtCt_myjq('.advice_notice').html('Constant Contact First Name is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#ctct_first_name').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if(!CtCt_LName.length){
               cUsCtCt_myjq('.advice_notice').html('Constant Contact Last Name is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#ctct_last_name').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if( !CtCt_email.length){
               cUsCtCt_myjq('.advice_notice').html('Your Email is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#ctct_email').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if(!bValid){
                cUsCtCt_myjq('.advice_notice').html('Please enter a valid Email!').slideToggle().delay(1200).fadeOut(1200);
                cUsCtCt_myjq('#ctct_email').focus();
                cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else if(!CtCt_Website.length){
               cUsCtCt_myjq('.advice_notice').html('Your Website is a required field').slideToggle().delay(2000).fadeOut(2000);
               cUsCtCt_myjq('#ctct_web').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else{
                cUsCtCt_myjq('.cUsCtCt_Sendlistid').val('Loading . . .').attr({disabled:'disabled'});
                
                postData = {action: 'cUs_CtCt_sendClientList', listID:mcListID, Fname:CtCt_Fname, LName:CtCt_LName, uEmail:CtCt_email, website:CtCt_Website};
                
                cUsCtCt_myjq.ajax({ type: "POST", url: ajax_object.ajax_url, data: postData,
                    success: function(data) {

                        switch(data){
                            case '1':
                                message = '<p>Welcome to ContactUs.com, and thank you for your registration.</p>';
                                message += '<p><b>We have sent a verification email.</b>.<br/>Please find the email, and login to your new ContactUs.com account.</p>';
                                
                                setTimeout(function(){
                                    cUsCtCt_myjq('.step3').slideUp().fadeOut();
                                    location.reload();
                                },3000)
                            break;
                            case '2':
                                message = 'Seems like you already have one Contactus.com Account, Please Login below!';
                                setTimeout(function(){
                                    cUsCtCt_myjq('.step2').slideUp().fadeOut();
                                    cUsCtCt_myjq('.step3').slideDown().delay(800);
                                },3000)
                            break;  
                            default:
                                message = '<p>Ouch! unfortunately there has being an error during the application: <b>' + data + '</b>. Please try again!</p>';
                                cUsCtCt_myjq('.cUs_CtCt_sendapikey').val('Continue to Step 3').removeAttr('disabled');
                            break;
                        }
                        
                        cUsCtCt_myjq('.loadingMessage').fadeOut();
                        //cUsCtCt_myjq('.advice_notice').html(message).show().delay(2500).fadeOut(800);
                        cUsCtCt_myjq('.advice_notice').html(message).show();

                    },
                    async: false
                });
           }
           
            
        });
    }catch(err){
        cUsCtCt_myjq('.advice_notice').html('Oops, something wrong happened, please try again later! ' + err).slideToggle().delay(1200).fadeOut(1200);
    }
    
    
    cUsCtCt_myjq('.cUs_CtCt_LoginUser').click(function(){//LOGIN ALREADY USERS
        var email = cUsCtCt_myjq('#login_email').val();
        var pass = cUsCtCt_myjq('#user_pass').val();
        cUsCtCt_myjq('.loadingMessage').show();
        
        if(!email.length){
            cUsCtCt_myjq('.advice_notice').html('User Email is a required and valid field!').slideToggle().delay(1200).fadeOut(1200);
            cUsCtCt_myjq('#login_email').focus();
            cUsCtCt_myjq('.loadingMessage').fadeOut();
        }else if(!pass.length){
            cUsCtCt_myjq('.advice_notice').html('User password is a required field!').slideToggle().delay(1200).fadeOut(1200);
            cUsCtCt_myjq('#user_pass').focus();
            cUsCtCt_myjq('.loadingMessage').fadeOut();
        }else{
            var bValid = checkRegexp( email, /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i, "eg. sergio@jquery.com" );  
            if(!bValid){
                cUsCtCt_myjq('.advice_notice').html('Please enter a valid User Email!').slideToggle().delay(1200).fadeOut(1200);
                cUsCtCt_myjq('.loadingMessage').fadeOut();
            }else{
                cUsCtCt_myjq.ajax({ type: "POST", url: ajax_object.ajax_url, data: {action:'cUs_CtCt_loginAlreadyUser',email:email,pass:pass},
                    success: function(data) {

                        switch(data){
                            case '1':
                                message = '<p>Welcome to ContactUs.com, and thank you for your registration.</p>';
                                //message += '<p>First we’ll need to activate your account. We have sent a verification email to <b>' + email + '</b>.<br/>Please find the email, and click on the activation link in the email.  Then, come back to this page.</p>';
                                
                                setTimeout(function(){
                                    cUsCtCt_myjq('.step3').slideUp().fadeOut();
                                    //cUsCtCt_myjq('.mainWindow').slideDown().delay(800);
                                    location.reload();
                                },2000)
                                
                            break;
                            default:
                                message = '<p>Ouch! unfortunately there has being an error during the application: <b>' + data + '</b>. Please try again!</a></p>';
                                break;
                        }
                        
                        cUsCtCt_myjq('.loadingMessage').fadeOut();
                        cUsCtCt_myjq('.advice_notice').html(message).show();

                    },
                    async: false
                });
            }
        }
    });
    
    cUsCtCt_myjq('.cUs_CtCt_LogoutUser').click(function(){
        if(confirm('Are you sure you want to quit?')){
            cUsCtCt_myjq('.loadingMessage').show();
            cUsCtCt_myjq.ajax({ type: "POST", url: ajax_object.ajax_url, data: {action:'cUs_CtCt_logoutUser'},
                success: function(data) {
                    cUsCtCt_myjq('.loadingMessage').fadeOut();
                      location.reload();
                },
                async: false
            });
        }
    });
    
    
    try{ cUsCtCt_myjq('.sendtemplate').click(function() {
           
           var mcApiKey = cUsCtCt_myjq('#apikey').val();
           var mcTemplateID = cUsCtCt_myjq('#templateid').val();
           cUsCtCt_myjq('.loadingMessage').show();
           
           if(!mcApiKey.length){
               cUsCtCt_myjq('.advice_notice').html('Constant Contact API Key is a required field!').slideToggle().delay(1200).fadeOut(1200);
               cUsCtCt_myjq('#apikey').focus();
               cUsCtCt_myjq('.loadingMessage').fadeOut();
           }else{
                
                cUsCtCt_myjq.ajax({ type: "POST", url: ajax_object.ajax_url, data: {action:'sendTemplateID',templateID:mcTemplateID},
                    success: function(data) {

                        switch(data){
                            case '1':
                                message = 'Template saved succesfuly . . . .';
                                
                                setTimeout(function(){
                                    cUsCtCt_myjq('.step3').slideUp().fadeOut();
                                    cUsCtCt_myjq('.step4').slideDown().delay(800);
                                },2000)
                                
                            break;
                        }
                        
                        cUsCtCt_myjq('.loadingMessage').fadeOut();
                        cUsCtCt_myjq('.advice_notice').html(message).show().delay(1900).fadeOut(800);

                    },
                    async: false
                });
           }
           
            
        });
    }catch(err){
        cUsCtCt_myjq('.advice_notice').html('Oops, something wrong happened, please try again later!').slideToggle().delay(1200).fadeOut(1200);
    }
    
    
    cUsCtCt_myjq('.form_version').change(function(){
        var val = cUsCtCt_myjq(this).val();
        cUsCtCt_myjq('.cus_versionform').fadeOut();
        cUsCtCt_myjq('.' + val).slideToggle();
    });
    
    cUsCtCt_myjq('#contactus_settings_page').change(function(){
        cUsCtCt_myjq('.show_preview').fadeOut();
        cUsCtCt_myjq('.save_page').fadeOut( "highlight" ).fadeIn().val('>> Save your settings');
    });
    
    
    cUsCtCt_myjq('.callout-button').click(function() {
        cUsCtCt_myjq('.getting_wpr').slideToggle('slow');
    });
    
    cUsCtCt_myjq('#mc_yes').click(function() {
        cUsCtCt_myjq('#cUs_CtCt_mcsettings').slideToggle('slow');
    });
    
    function checkRegexp( o, regexp, n ) {
        if ( !( regexp.test( o ) ) ) {
            return false;
        } else {
            return true;
        }
    }
    
    function checkURL(value) {
        var urlregex = new RegExp("^(http:\/\/www.|https:\/\/www.|ftp:\/\/www.|www.){1}([0-9A-Za-z]+\.)");
        if (urlregex.test(value)) {
            return (true);
        }
        return (false);
    }
    
    
});
